﻿// mp3_14.h
#ifndef MP3_14_H_
#define MP3_14_H_

#define		MAX_DIRS				1000				// DIR総数
#define		DIRPATH_LEN				512					// DIRパスの最大長（バイト）
#define		MP3FILE_LEN				192					// MP3ファイルの最大ファイル名長(バイト)

// DIR構成ファイル　レコード長・項目別バイトサイズ
#define		DIRSTRUCTUREFILE14				"DIRLST14.DAT"		// DIR構成ファイル(Version=14)
#define		RECLEN_DIRLIST					768UL				// レコード長(0x300)
#define		RECLEN_DIRLIST_FULL				768UL				// レコード長(0x300)
#define		DL_CRDATETIME_OFFSET			4					// ヘッダレコードの作成日時
#define		DL_CRDATETIME_LEN				14
#define 	DL_DISPLAYNAME_OFFSET			0					// ディレクトリ表示名
#define 	DL_DISPLAYNAME_LEN				48
#define 	DL_FULLDIR_OFFSET				48					// ディレクトリフルパス
#define 	DL_FULLDIR_LEN					(DIRPATH_LEN + 1)
#define 	DL_LENFULLDIR_OFFSET			561					// ディレクトリフルパスバイト数
#define 	DL_LENFULLDIR_LEN				2
#define		DL_DIRNAME_OFFSET				563					// ディレクトリ名
#define		DL_DIRNAME_LEN					128
#define 	DL_RECNO_SUBDIR_OFFSET			691					// サブディレクトリの先頭レコード番号
#define 	DL_RECNO_SUBDIR_LEN				2
#define 	DL_NUM_SUBDIR_OFFSET        	693					// サブディレクトリ数
#define 	DL_NUM_SUBDIR_LEN				1
#define 	DL_RECNO_PARENTDIR_OFFSET		694					// 親ディレクトリのレコード番号
#define 	DL_RECNO_PARENTDIR_LEN			2
#define		DL_RECNO_GRANDPARENTDIR_OFFSET	696					// 親々ディレクトリのレコード番号
#define 	DL_RECNO_GRANDPARENTDIR_LEN		2
#define 	DL_NUM_SNDFILE_OFFSET			698					// MP3ファイル数
#define 	DL_NUM_SNDFILE_LEN				1
#define		DL_RECNO_SNDFILE_OFFSET			699					// MP3ファイルリストの最初の曲のレコード番号
#define		DL_RECNO_SNDFILE_LEN			2
#define 	DL_FILLER_14					67					// 

// 音源ファイルリスト
#define		SNDFILELISTFILE				"SNDLST14.DAT"			// MP3ファイルリスト(Version=14)
#define		RECLEN_MP3LIST				512UL					// レコード長
#define		RECLEN_MP3LIST_FULL			512UL					// レコード長
#define 	ML_TITLENAME_OFFSET			0
#define 	ML_TITLENAME_LEN			128
#define 	ML_FILENAME_OFFSET			128
#define 	ML_FILENAME_LEN				(MP3FILE_LEN + 1)
#define 	ML_FILLER_14				191

// ランダム再生順ファイル
#define		RANDOMORDERFILE			"RANDOM14.DAT"
#define		RECLEN_RANDOMORDER		4
#define		RO_RANDOMTYPE_OFFSET	0		// 再生単位
#define		RO_RANDOMTYPE_LEN		1
#define		RO_DIRNO_OFFSET			1		// ディレクトリレコード番号
#define		RO_DIRNO_LEN			2
#define		RO_TRACKNO_OFFSET		3		// MP3ファイルリストのレコード番号
#define		RO_TRACKNO_LEN			1

#define		RANDOMTYPE_FOLDER		0		// ランダム再生単位：フォルダ
#define		RANDOMTYPE_FILE			1		// ランダム再生単位：ファイル


// 履歴ファイル
#define		HISTFILE				"HIST14.DAT"		// 履歴ファイル
#define 	RECLEN_HISTFILE       	9UL
#define 	HS_LASTDIR_OFFSET       0		// 再生中のディレクトリの番号
#define 	HS_LASTDIR_LEN          2
#define 	HS_LASTTRACK_OFFSET		2
#define 	HS_LASTTRACK_LEN        1
#define 	HS_LASTTIME_OFFSET		3
#define 	HS_LASTTIME_LEN         4
#define		HS_RANDRECNO_OFFSET		7
#define		HS_RANDRECNO_LEN		2

#define		HIST_RANDOMFLG_RANDOM	1		// "再生中のディレクトリの番号"はランダム再生中
#define		HIST_RANDOMFLG_SELECT	0

// ボリュームファイル
#define 	VOLUMEFILE              "VOLUME14.DAT"

// その他
#define		SND_ROOT				"/snd"				// 音源のルート
#define		DIRLISTFILE				"dirlstwk.txt"		// mp3_14_mkflの中間ファイル。

#endif /* MP3_14_H_ */
